﻿using System;
using System.IO;
using System.Threading;

using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.Profiles;
using Styx.Helpers;
using Styx.Pathing;
using Styx.TreeSharp;
using Styx.WoWInternals;



using Action = Styx.TreeSharp.Action;

namespace BgBot.Behaviors
{
    public class ActionLeaveBattleground : Action
    {
        private static void BattlegroundLeft()
        {
            TreeRoot.StatusText = "Left the battleground, YO~!";

            string fullPath = CharacterSettings.Instance.LastUsedPath;

            if (!File.Exists(fullPath))
            {
                if (!string.IsNullOrEmpty(fullPath))
                    Logging.Write("Honorbuddy was unable to find file {0}", fullPath);

                return;
            }

            ProfileManager.LoadNew(fullPath);
            BotEvents.Battleground.FireBattlegroundLeft();


            //Attempt to stop random running at end of BG
            Navigator.Clear();
            Thread.Sleep(1750);
        }

        #region Overrides of Behavior

        /// <summary>
        ///   Actually executes one behavior tick
        /// </summary>
        /// <returns></returns>
        protected override RunStatus Run(object context)
        {
            BattlefieldWinner winner = Battlegrounds.Winner;
            var horde = StyxWoW.Me.IsHorde;

            
            if ((horde && winner == BattlefieldWinner.Horde) || (!horde && winner == BattlefieldWinner.Alliance))
            {
                //InfoPanel.BGWon();
                GameStats.BGWon();
            }
            else
            {
                GameStats.BGLost();
                //InfoPanel.BGLost();
            }

            Thread.Sleep(2500);
            Battlegrounds.LeaveBattlefield();

            int tickCount = Environment.TickCount;
            while (StyxWoW.IsInGame && Environment.TickCount - tickCount <= 20000)
            {
                Thread.Sleep(100);
            }

            tickCount = Environment.TickCount;
            while (!StyxWoW.IsInGame && Environment.TickCount - tickCount <= 20000)
            {
                Thread.Sleep(100);
            }

            Thread.Sleep(1000);
            ObjectManager.Update();

            BattlegroundLeft();
            return RunStatus.Success;
        }

        #endregion
    }
}