﻿using System.Linq;
using Styx;
using Styx.Helpers;

using Styx.TreeSharp;
using Styx.WoWInternals;



namespace BgBot.Behaviors
{
    public class DecoratorNeedToEnqueue : Decorator
    {
        public DecoratorNeedToEnqueue(Composite child)
            : base(child)
        {
        }

        protected override bool CanRun(object context)
        {
            if (StyxWoW.Me.HasAura("Deserter"))
                return false;

            if (Battlegrounds.IsInsideBattleground)
                return false;

            int queueCount = 0;
            if (BBRSettings.Instance.BG1 != BattlegroundType.None)
                queueCount++;
            if (BBRSettings.Instance.BG2 != BattlegroundType.None)
                queueCount++;

            var queuedBgs = Battlegrounds.BattlegroundStatuses.Count(s => s == BattlegroundStatus.Queued);
            return queuedBgs < queueCount;
        }
    }
}