﻿using System;
using System.ComponentModel;
using System.IO;
using Bots.BGBuddy.HeatMap;
using Styx.Helpers;
using Styx;

using Styx.WoWInternals;

namespace BgBot
{

    public enum PlayStyle
    {
        Defensive,
        Neutral,
        Offensive,
        Random
    }


    public class BBRSettings : Settings
    {
        public static readonly BBRSettings Instance = new BBRSettings();

        public BBRSettings()
            : base(Path.Combine(Styx.Common.Utilities.AssemblyDirectory, string.Format(@"Settings\{0}\{1}\BBR.xml",StyxWoW.Me.RealmName,StyxWoW.Me.Name)))
        {




        }

        [Category("Playstyles")]
        [DisplayName("Alterac Valley")]
        [Setting]
        [Styx.Helpers.DefaultValue(PlayStyle.Neutral)]
        public PlayStyle avplaystyle { get; set; }

        [Category("Playstyles")]
        [DisplayName("Warsong Gulch")]
        [Setting]
        [Styx.Helpers.DefaultValue(PlayStyle.Neutral)]
        public PlayStyle wsgPlaystyle { get; set; }

        [Category("Playstyles")]
        [DisplayName("Arathi Basin")]
        [Setting]
        [Styx.Helpers.DefaultValue(PlayStyle.Neutral)]
        public PlayStyle abPlaystyle { get; set; }

        [Category("Playstyles")]
        [DisplayName("Eye of the Storm")]
        [Setting]
        [Styx.Helpers.DefaultValue(PlayStyle.Neutral)]
        public PlayStyle eotsPlaystyle { get; set; }

        [Category("Playstyles")]
        [DisplayName("Twin Peaks")]
        [Setting]
        [Styx.Helpers.DefaultValue(PlayStyle.Neutral)]
        public PlayStyle tpPlaystyle { get; set; }

        [Category("Playstyles")]
        [DisplayName("Battle for Gilneas")]
        [Setting]
        [Styx.Helpers.DefaultValue(PlayStyle.Neutral)]
        public PlayStyle bfgPlaystyle { get; set; }

        [Category("Playstyles")]
        [DisplayName("Temple of Kotmogu")]
        [Setting]
        [Styx.Helpers.DefaultValue(PlayStyle.Neutral)]
        public PlayStyle tokPlaystyle { get; set; }

        [Category("Playstyles")]
        [DisplayName("Silvershard Mines")]
        [Setting]
        [Styx.Helpers.DefaultValue(PlayStyle.Neutral)]
        public PlayStyle smPlaystyle { get; set; }



        /*[Category("Playstyles")]
        [DisplayName("Strand of the Ancients")]
        [Setting]
        [Styx.Helpers.DefaultValue(PlayStyle.Neutral)]
        public PlayStyle avplaystyle { get; set; }


        [Category("Playstyles")]
        [DisplayName("Isle of Conquest")]
        [Setting]
        [Styx.Helpers.DefaultValue(PlayStyle.Neutral)]
        public PlayStyle avplaystyle { get; set; }


        [Category("Playstyles")]
        [DisplayName("Deepwind Gorge")]
        [Setting]
        [Styx.Helpers.DefaultValue(PlayStyle.Neutral)]
        public PlayStyle avplaystyle { get; set; }*/






        [Category("Targeting")]
        [Setting]
        [Styx.Helpers.DefaultValue(false)]
        public bool IncludeMountedPlayers { get; set; }


        [Category("Battlegronds")]
        [DisplayName("Battleground 1")]
        [Setting]
        [Styx.Helpers.DefaultValue(BattlegroundType.None)]
        public BattlegroundType BG1 { get; set; }
        [Category("Battlegronds")]
        [DisplayName("Battleground 2")]
        [Setting]
        [Styx.Helpers.DefaultValue(BattlegroundType.None)]
        public BattlegroundType BG2 { get; set; }
    }

}
