﻿using System;
using Styx;
using Styx.Helpers;


namespace BgBot
{
    public class GateWaitArea
    {
        public WoWPoint[] WaitLocations { get; set; }

        public float MaxRadius { get; set; }

        public GateWaitArea(float maxRadius, WoWPoint[] waitLocations)
        {
            WaitLocations = waitLocations;
            MaxRadius = maxRadius;
        }

        private WoWPoint _selectedLocation = WoWPoint.Empty;
        public WoWPoint SelectLocation()
        {
            if (_selectedLocation != WoWPoint.Empty)
                return _selectedLocation;

            Random rand = new Random(Environment.TickCount);
            WoWPoint randomLoc = WaitLocations[rand.Next(0, WaitLocations.Length)];

            var randomDegrees = rand.Next(0, 360);
            float radians = WoWMathHelper.DegreesToRadians(randomDegrees);

            _selectedLocation = randomLoc.RayCast(radians, MaxRadius);
            return _selectedLocation;
        }
    }
}
