﻿using System;
using System.Collections.Generic;
using System.Reflection;
using System.Text;
using System.Windows.Forms;
using Styx;
using Styx.Common;
using Styx.Helpers;
using Styx.TreeSharp;
using Styx.WoWInternals;

namespace BgBot.Gui
{
    [Obfuscation(Exclude = true, ApplyToMembers = false)]
	public partial class FormBGSettings : Form
	{
		public FormBGSettings()
		{
		    InitializeComponent();
		}

		public List<BattlegroundType> SelectedBGs = new List<BattlegroundType>();

		private void FormPVPSettings_Load(object sender, EventArgs e)
		{
            /*_cbxAB.CheckedChanged += (s, args) => SetInternalBG(BattlegroundType.AB, _cbxAB.Checked);
            _cbxAV.CheckedChanged += (s, args) => SetInternalBG(BattlegroundType.AV, _cbxAV.Checked);
            _cbxEotS.CheckedChanged += (s, args) => SetInternalBG(BattlegroundType.EotS, _cbxEotS.Checked);
            _cbxIOC.CheckedChanged += (s, args) => SetInternalBG(BattlegroundType.IoC, _cbxIOC.Checked);
            _cbxSOTA.CheckedChanged += (s, args) => SetInternalBG(BattlegroundType.SotA, _cbxSOTA.Checked);
            _cbxWSG.CheckedChanged += (s, args) => SetInternalBG(BattlegroundType.WSG, _cbxWSG.Checked);
            _cbxBFG.CheckedChanged += (s, args) => SetInternalBG(BattlegroundType.BfG, _cbxBFG.Checked);
		    _cbxTP.CheckedChanged += (s, args) => SetInternalBG(BattlegroundType.TP, _cbxTP.Checked);

            _cbToK.CheckedChanged += (s, args) => SetInternalBG(BattlegroundType.ToK, _cbToK.Checked);
            _cbSM.CheckedChanged += (s, args) => SetInternalBG(BattlegroundType.SM, _cbSM.Checked);


            _cbxRandomBattleground.CheckedChanged += (s, args) => SetInternalBG(BattlegroundType.RandomBattleground, _cbxRandomBattleground.Checked);
            _cbxInludeMountedPlayers.CheckedChanged += (s, args) => BBRSettings.Instance.IncludeMountedPlayers = _cbxInludeMountedPlayers.Checked;

            //chkFrameLock.CheckedChanged += new EventHandler(chkFrameLock_CheckedChanged);

            
            trackBar1.ValueChanged += (s, args) => BBRSettings.Instance.Stance = trackBar1.Value;

			RefreshEnabledBGs();*/
            LoadSettings();
			//_btnSave.Enabled = false;
		}

        void propertyGrid1_PropertyValueChanged(object s, System.Windows.Forms.PropertyValueChangedEventArgs e)
        {
            if (BBRSettings.Instance.BG1 == BattlegroundType.RandomBattleground)
                BBRSettings.Instance.BG2 = BattlegroundType.None;

            if (BBRSettings.Instance.BG2 == BattlegroundType.RandomBattleground)
            {
                BBRSettings.Instance.BG1 = BattlegroundType.RandomBattleground;
                BBRSettings.Instance.BG2 = BattlegroundType.None;
            }
        }



		private void LoadSettings()
		{
            BBRSettings.Instance.Load();


            propertyGrid1.SelectedObject = BBRSettings.Instance;
		}



		private void SetInternalBG(BattlegroundType bg, bool enabled)
		{
			if (!enabled)
			{
				SelectedBGs.Remove(bg);
			}
			else
			{
                // BUG: Temp fix for WoW bugging out, and not letting us queue 2 BGs.
				while (SelectedBGs.Count >= 2 || bg == BattlegroundType.RandomBattleground && SelectedBGs.Count > 0 || SelectedBGs.Contains(BattlegroundType.RandomBattleground))
				{
					//SetBG(SelectedBGs[0], false);
				}

				SelectedBGs.Add(bg);
				//_btnSave.Enabled = true;
			}
		}



        private void FormBGSettings_FormClosed(object sender, FormClosedEventArgs e)
        {

            BBRSettings.Instance.Save();
            BgBot._form = null;
        }


	}
}