﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using Styx.Common;
using Styx.Helpers;

using Styx.WoWInternals;
using Vector2 = Tripper.Tools.Math.Vector2;

namespace BgBot.Logic
{
    public class ArathiBasin : HoldPointBattleground
    {


        //[Blacksmith: Uncontrolled]: Entry: 1614 NormalIcon:26 Location:<988.933, 1012.57, -42.48231> MapId:529 AreaId:-1 Flags:Zone, Bg, ShowInBattlemap WorldState:1 ShowInBattleMap:True ShowInBg:True ShowInZone:True TextureIndex:26 MapX:0.4815734 MapY:0.4436159
        //[Farm: Uncontrolled]: Entry: 1629 NormalIcon:31 Location:<0, 0, 0> MapId:529 AreaId:-1 Flags:Zone, Bg, ShowInBattlemap WorldState:1 ShowInBattleMap:True ShowInBg:True ShowInZone:True TextureIndex:31 MapX:0.5876061 MapY:0.5842602
        //[Gold Mine: Uncontrolled]: Entry: 1624 NormalIcon:16 Location:<1178.22, 822.509, -82.34483> MapId:529 AreaId:-1 Flags:Zone, Bg, ShowInBattlemap WorldState:1 ShowInBattleMap:True ShowInBg:True ShowInZone:True TextureIndex:16 MapX:0.5897932 MapY:0.2819473
        //[Lumber Mill: Uncontrolled]: Entry: 1619 NormalIcon:21 Location:<813.067, 1182.09, 32.40463> MapId:529 AreaId:-1 Flags:Zone, Bg, ShowInBattlemap WorldState:1 ShowInBattleMap:True ShowInBg:True ShowInZone:True TextureIndex:21 MapX:0.3850496 MapY:0.5938218
        //[Stables: Uncontrolled]: Entry: 1609 NormalIcon:36 Location:<1180.92, 1185.77, -45.44314> MapId:529 AreaId:-1 Flags:Zone, Bg, ShowInBattlemap WorldState:1 ShowInBattleMap:True ShowInBg:True ShowInZone:True TextureIndex:36 MapX:0.3829542 MapY:0.2796412



        public override PlayStyle Stance
        {
            get
            {
                var ps = BBRSettings.Instance.abPlaystyle;
                return ps != PlayStyle.Random ? _randomPlaystyle : ps;
            }
        }

        public override BattlegroundType BgType
        {
            get { return BattlegroundType.AB; }
        }

        public override string ProfileName
        {
            get
            {
                return "ArathiBasin";
            }
        }
    }
}


/*

AB Logic

5 capture points - Stables, BS, LM, Mine, Farm

Out of the gate -
 * Alliance ->  Stables
 * Horde -> Farm
 * 
 * Both need to cap ASAP - If its already being capped, ignore, and move to point #2

Out of the gate passed first marker -
 * Alliance -> LM
 * Horde -> LM
 *  - Yes, we want both sides to go to LM. This ensures we seem 'human' as we'll be fighting over LM anyway!
 * Again; cap ASAP

At this point there should be 2 flags being capped, with a 5th being controlled by either side (whoever is quicker, we don't really care)
 * STAND YOUR GROUND at #2 until the 5th one is being capped, so its known where you may need to go!












*/