﻿using System.Collections.Generic;
using System.Linq;
using Styx.Common;
using Styx.Helpers;
using Vector2 = Tripper.Tools.Math.Vector2;

namespace BgBot.Logic
{
    public abstract class BoxOnlyBattleground : Battleground
    {
        public override PvpHotspot GetFightLocation(IEnumerable<Vector2> playerLocations, IEnumerable<PvpHotspot> hotspots)
        {
            foreach (var h in hotspots)
            {
                h.LastPlayerCount = 0;
            }
            foreach (var h in hotspots)
            {
                h.LastPlayerCount = RaidHelper.GetCountWithin(h.Box, playerLocations);
                if (h.LastPlayerCount != 0)
                    Logging.WriteDiagnostic(h.Name + " => " + h.LastPlayerCount);
            }

            PvpHotspot best = GetHighestDensity(hotspots);

            // Return the best, or the default if there is no current 'best'.
            return best ?? hotspots.First(h=>h.IsDefault);
        }

        //public virtual PvpHotspot GetLowestFightLocation(IEnumerable<Vector2> playerLocations, IEnumerable<PvpHotspot> hotspots)
        //{
        //    foreach (var h in hotspots)
        //    {
        //        h.LastPlayerCount = 0;
        //    }
        //    foreach (var h in hotspots)
        //    {
        //        h.LastPlayerCount = RaidHelper.GetCountWithin(h.Box, playerLocations);
        //    }

        //    PvpHotspot best = GetLowestDensity(hotspots);

        //    // Return the best, or the default if there is no current 'best'.
        //    return best ?? hotspots.First(h => h.IsDefault);
        //}
    }
}