﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Timers;
using Bots.BGBuddy;
using Bots.BGBuddy.Logic.Battlegrounds;
using Styx;
using Styx.Common;
using Styx.Helpers;
using Styx.Pathing;
using Styx.TreeSharp;
using Styx.WoWInternals;

using System.Linq;
using Tripper.MeshMisc;
using Tripper.Navigation;
using Tripper.RecastManaged.Detour;
using Action = Styx.TreeSharp.Action;


namespace BgBot.Logic
{
    public class StrandOfTheAncients : BoxOnlyBattleground
    {
        public override BattlegroundType BgType
        {
            get { return BattlegroundType.SotA; }
        }

        private MeshNavigator meshNav;
        private IEnumerable<StrandOfTheAncientsLandmark> marks;
        private Dictionary<int, LandmarkInfo> nodes;

       

        private Composite BoatLogic;
        private Composite GateLogic;
        private bool _CheckGates;
        private Timer CheckGates;

        public StrandOfTheAncients()
        {
            meshNav = Navigator.NavigationProvider as MeshNavigator;

            nodes = new Dictionary<int, LandmarkInfo>();


            CheckGates = new Timer();
            CheckGates.Elapsed += CheckGates_Elapsed;
            CheckGates.Interval = 5000;
            CheckGates.Enabled = true;



            BoatLogic = new Decorator(r => StyxWoW.Me.IsOnTransport && !StyxWoW.Me.HasAura("Preparation"), new Action(z => WoWMovement.ClickToMove(hashSet_1.OrderBy(r => r.Distance(StyxWoW.Me.Location)).FirstOrDefault())));
            TreeHooks.Instance.AddHook("BgBot_Special_1", BoatLogic);


            GateLogic = new Decorator(r=> _CheckGates, new Action(delegate
                                                                      {

                                                                          _CheckGates = false;
                                                                          method_17();



                                                                      }));

            TreeHooks.Instance.AddHook("BgBot_Special_1", GateLogic);
            meshNav.Nav.OnTileLoaded += Nav_OnTileLoaded;
            meshNav.Nav.OnSubTileLoaded += Nav_OnSubTileLoaded;

            method_17();
        }

        void CheckGates_Elapsed(object sender, ElapsedEventArgs e)
        {
            _CheckGates = true;
        }

        public override void  Dispose()
        {

            CheckGates.Enabled = false;
            BgBot.Log("Cleaning up");
            TreeHooks.Instance.RemoveHook("BgBot_Special_1", BoatLogic);
            TreeHooks.Instance.RemoveHook("BgBot_Special_1", GateLogic);
            meshNav.Nav.OnTileLoaded -= Nav_OnTileLoaded;
            meshNav.Nav.OnSubTileLoaded -= Nav_OnSubTileLoaded;
            base.Dispose();
        }

        private readonly HashSet<WoWPoint> hashSet_1 = new HashSet<WoWPoint>
		{
			new WoWPoint(1610.332f, 50.70834f, 7.579856f),
			new WoWPoint(1599.641f, -102.9774f, 8.8739f)
		};

        private void UnloadAllTiles(string status)
        {
            meshNav.Nav.UnloadAllTiles();
            BgBot.Log("Unloading all tiles. Reason(s): {0}", status);
            Navigator.Clear();
        }

        void Nav_OnSubTileLoaded(object sender, Tripper.Navigation.TileLoadedEventArgs e)
        {

            MeshTile tileAt = ((WowNavigator)sender).Mesh.GetTileAt(e.Tile.X, e.Tile.Y);
            if (tileAt != null)
            {
                ModifyGates(tileAt);
            }

        }

        void Nav_OnTileLoaded(object sender, Tripper.Navigation.TileLoadedEventArgs e)
        {
            MeshTile tileAt = ((WowNavigator)sender).Mesh.GetTileAt(e.Tile.X, e.Tile.Y);
            if (tileAt != null)
            {
                ModifyGates(tileAt);
            }
        }

        public override string ProfileName
        {
            get
            {

                return "StrandOfTheAncients";
            }
        }

        private IEnumerable<StrandOfTheAncientsLandmark> Statuses
        {
            get
            {
                return
                   Battlegrounds.LandMarks.LandmarkList.Select(l => l.ToStrandOfTheAncientsLandmark());

            }
        }



        //Alot of this stuff was RE'd from the honorbuddy executable
        //The logic comes from bgbuddy.

        private static bool smethod_0(StrandOfTheAncientsLandmark landmarkInfo_0)
        {
            return landmarkInfo_0.LandmarkType == StrandOfTheAncientsLandmarkType.HordeDefense; // HordeDefense
        }

        private static bool smethod_1(StrandOfTheAncientsLandmark landmarkInfo_0)
        {
            return landmarkInfo_0.LandmarkType == StrandOfTheAncientsLandmarkType.AllianceDefense; // AllianceDefense
        }

        private Func<StrandOfTheAncientsLandmark, bool> func_0;
        private Func<StrandOfTheAncientsLandmark, bool> func_1;
        protected bool IsAttacking
        {
            get
            {
                bool result;
                if (StyxWoW.Me.IsHorde)
                {
                    IEnumerable<StrandOfTheAncientsLandmark> arg_34_0 = Statuses;
                    if (func_0 == null)
                    {
                        func_0 = new Func<StrandOfTheAncientsLandmark, bool>(smethod_0);
                    }
                    result = !arg_34_0.Any(func_0);
                }
                else
                {
                    IEnumerable<StrandOfTheAncientsLandmark> arg_67_0 = Statuses;
                    if (func_1 == null)
                    {
                        func_1 = new Func<StrandOfTheAncientsLandmark, bool>(smethod_1);
                    }
                    result = !arg_67_0.Any(func_1);
                }
                return result;
            }
        }

        private void method_17()
        {
            /*Class590.Class616 @class = new Class590.Class616();
            Battlegrounds.LandMarks.Refresh();
            Class590.Class616 arg_3F_0 = @class;
            IEnumerable<WoWLandMark> arg_3A_0 = Battlegrounds.LandMarks.LandmarkList;
            if (Class590.func_25 == null)
            {
                Class590.func_25 = new Func<WoWLandMark, StrandOfTheAncientsLandmark>(Class590.smethod_72);
            }
            arg_3F_0.ienumerable_0 = arg_3A_0.Select(Class590.func_25);*/

            Battlegrounds.LandMarks.Refresh();

            bool flag = false;
            StringBuilder stringBuilder = new StringBuilder();
            stringBuilder.AppendLine();
            foreach (StrandOfTheAncientsLandmark current in Statuses)
            {

                    if (!nodes.ContainsKey((int) current.LandmarkType))
                    {
                        nodes.Add((int) current.LandmarkType,
                                  new LandmarkInfo((int) current.LandmarkType, current.ControlType,new Bots.BGBuddy.MapBox(), null));
                        if ((current.LandmarkType & StrandOfTheAncientsLandmarkType.Gates) !=
                            StrandOfTheAncientsLandmarkType.Unknown)
                        {
                            flag = true;
                            stringBuilder.AppendLine(string.Format("{0} has been added", current.LandmarkType));
                        }
                    }
                    else
                    {
                        LandmarkControlType control = nodes[(int) current.LandmarkType].Control;
                        LandmarkControlType controlType = current.ControlType;
                        if (control != controlType && controlType != LandmarkControlType.Unknown &&
                            controlType != LandmarkControlType.InConflict)
                            // &&(current.LandmarkType & StrandOfTheAncientsLandmarkType.Gates) != StrandOfTheAncientsLandmarkType.Unknown)
                        {
                            flag = true;
                            stringBuilder.AppendLine(string.Format(
                                "State of {0} changed. Old Value: {1} New Value: {2}",
                                current.LandmarkType, control, controlType));
                        }
                        nodes[(int) current.LandmarkType] = new LandmarkInfo((int) current.LandmarkType,
                                                                             current.ControlType,
                                                                             new Bots.BGBuddy.MapBox(), null);
                    }
                    //nodes[(int)current.LandmarkType].Process();
                
            }
            if (flag)
            {
                UnloadAllTiles(stringBuilder.ToString());
            }
            nodes.RemoveAll(method_0);
        }


        private sealed class Class615
        {
            //public Class616 class616_0;
            public LandmarkInfo landmarkInfo_0;
            public bool method_0(StrandOfTheAncientsLandmark strandOfTheAncientsLandmark_0)
            {
                return strandOfTheAncientsLandmark_0.LandmarkType == (StrandOfTheAncientsLandmarkType)this.landmarkInfo_0.Type;
            }
        }

        public bool method_0(LandmarkInfo landmarkInfo_0)
        {
            Class615 @class = new Class615();
            //@class.class616_0 = this;
            @class.landmarkInfo_0 = landmarkInfo_0;
            bool result;
            if (!Statuses.Any(new Func<StrandOfTheAncientsLandmark, bool>(@class.method_0)))
            {
                result = true;
            }
            else
            {
                result = false;
            }
            return result;
        }

        private void ModifyGates(MeshTile tile)
        {
            var usedTeleport = StyxWoW.Me.HasAura("Teleport");
            var destroyedLandmarks = Statuses.Where(l => l.ControlType == LandmarkControlType.Destroyed);
            var polys = tile.GetAllPolys();
            foreach (var poly in polys)
            {
                switch ((AreaType)poly.Area)
                {
                    case AreaType.DefendersPortal:
                        poly.Flags =(ushort)AbilityFlags.Unwalkable;//IsAttacking || usedTeleport ? (ushort)AbilityFlags.Unwalkable : (ushort)AbilityFlags.Teleport;
                        break;
                }

                switch ((SotAGate)poly.Area)
                {
                    case SotAGate.Blue:
                        poly.Flags = destroyedLandmarks.Any(l => l.LandmarkType == StrandOfTheAncientsLandmarkType.GateOfTheBlueSapphire)
                                         ? (ushort)AbilityFlags.Run
                                         : (ushort)AbilityFlags.Unwalkable;
                        break;
                    case SotAGate.Green:
                        poly.Flags = destroyedLandmarks.Any(l => l.LandmarkType == StrandOfTheAncientsLandmarkType.GateOfTheGreenEmerald)
                                         ? (ushort)AbilityFlags.Run
                                         : (ushort)AbilityFlags.Unwalkable;
                        break;
                    case SotAGate.Purple:
                        poly.Flags = destroyedLandmarks.Any(l => l.LandmarkType == StrandOfTheAncientsLandmarkType.GateOfThePurpleAmethyst)
                                         ? (ushort)AbilityFlags.Run
                                         : (ushort)AbilityFlags.Unwalkable;
                        break;
                    case SotAGate.Red:
                        poly.Flags = destroyedLandmarks.Any(l => l.LandmarkType == StrandOfTheAncientsLandmarkType.GateOfTheRedSun)
                                         ? (ushort)AbilityFlags.Run
                                         : (ushort)AbilityFlags.Unwalkable;
                        break;
                    case SotAGate.Yellow:
                        poly.Flags = destroyedLandmarks.Any(l => l.LandmarkType == StrandOfTheAncientsLandmarkType.GateOfTheYellowMoon)
                                         ? (ushort)AbilityFlags.Run
                                         : (ushort)AbilityFlags.Unwalkable;
                        break;
                    default:
                        continue;
                }
            }
        }
    }
}