﻿using System;
using System.Globalization;
using System.Xml.Linq;

using Tripper.Tools.Math;

namespace BgBot
{
    /// <summary>
    ///   Map box.
    /// </summary>
    /// <remarks>
    ///   Created 12/19/2010.
    /// </remarks>
    public struct MapBox
    {
        /// <summary>
        ///   The bottom right
        /// </summary>
        public Vector2 BottomRight;

        /// <summary>
        ///   The top left
        /// </summary>
        public Vector2 TopLeft;

        internal static MapBox FromXml(XElement xml)
        {
            float tlX = Convert.ToSingle(xml.Attribute("tlx").Value, CultureInfo.InvariantCulture);
            float tlY = Convert.ToSingle(xml.Attribute("tly").Value, CultureInfo.InvariantCulture);
            float brX = Convert.ToSingle(xml.Attribute("brx").Value, CultureInfo.InvariantCulture);
            float brY = Convert.ToSingle(xml.Attribute("bry").Value, CultureInfo.InvariantCulture);

            Vector2 tl = new Vector2(tlX, tlY);
            Vector2 br = new Vector2(brX, brY);
            MapBox ret = new MapBox { TopLeft = tl, BottomRight = br };
            return ret;
        }

        public MapBox(Vector2 bottomRight, Vector2 topLeft)
        {
            BottomRight = bottomRight;
            TopLeft = topLeft;
        }

        public MapBox(float topLeftX, float bottomRightX, float topLeftY, float bottomRightY) : this(new Vector2(bottomRightX, bottomRightY), new Vector2(topLeftX, topLeftY)) { }
    }
}