﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Xml.Linq;

using Styx;
using Styx.CommonBot.Profiles;

using Styx.Pathing;
using Tripper.Tools.Math;

namespace BgBot
{
    public class PvpProfile
    {
        internal PvpProfile()
        {
            Hotspots = new List<PvpHotspot>();
            Blackspots = new List<Blackspot>();
        }

        public PvpProfile(XContainer xml)
            : this()
        {
            foreach (XElement hs in xml.Elements("Hotspot"))
            {
                Hotspots.Add(new PvpHotspot(hs));
            }
            foreach (var xElement in xml.Descendants("Blackspot"))
            {
                Blackspots.Add(new Blackspot(xElement));
            }


            foreach (var b in Blackspots)
            {
                // Simple enough.
                BlackspotManager.AddBlackspot(b.Location, b.Radius, b.Height);
            }
        }

        protected List<Blackspot> Blackspots { get; set; }

        public PvpProfile(string profilePath)
            : this(XElement.Load(profilePath))
        {
        }

        public List<PvpHotspot> Hotspots { get; set; }

        public List<PvpHotspot> FactionSpecificHotspots
        {
            get
            {
                return Hotspots.Where(h => (h.IsHorde == StyxWoW.Me.IsHorde) || h.IsNeutral).ToList();
            }
        }

        public static PvpProfile Current { get; set; }

        //public PvpHotspot GetCurrentHotspot()
        //{
        //    List<PvpHotspot> factionSpots = FactionSpecificHotspots;
        //    IEnumerable<Vector2> positions =
        //        RaidHelper.GetPlayerPositions().Where(m => !m.IsDead && m.MapPosition != Vector2.Zero).Select(
        //            m => m.MapPosition);

        //    foreach (PvpHotspot hotspot in factionSpots)
        //    {
        //        // Get the current count of *usable* players in this spot.
        //        int countInHotspot = RaidHelper.GetCountWithin(hotspot.Box.TopLeft, hotspot.Box.BottomRight, positions);

        //        // Set the last player count, because we can.
        //        hotspot.LastPlayerCount = countInHotspot;
        //    }
        //    int bestHotspot = 0;

        //    // Get the 'best' hotspot, we use some 'tricky dicky' math here, to make sure we don't flip back and forth
        //    for (int i = 0; i < factionSpots.Count; i++)
        //    {
        //        // Use 1.2 to make sure we only move if there's a big enough difference. (20% more than the current)
        //        if (factionSpots[i].LastPlayerCount * 1.2 > factionSpots[bestHotspot].LastPlayerCount)
        //        {
        //            bestHotspot = i;
        //        }
        //    }

        //    return factionSpots[bestHotspot];
        //}
    }
}